Texture2D txDiffuse : register( t0 );
SamplerState samLinear : register( s0 );

cbuffer cbNeverChanges : register( b0 )
{
    matrix View;
};

cbuffer cbChangeOnResize : register( b1 )
{
    matrix Projection;
};

cbuffer cbChangesEveryFrame : register( b2 )
{
    matrix World;
};
cbuffer CBSpriteData : register( b3 )
{
	float4 posx;
	float4 posy;
	float4 posz;
	float4 texu;
	float4 texv;
	int posmode;
	float3 dummy;
};
cbuffer CBPointData : register( b4 )
{
	float4 pos;
	float4 pointcolor;
};
cbuffer CBLineData : register( b5 )
{
	float4 pos0;
	float4 pointcolor0;
	float4 pos1;
	float4 pointcolor1;
};
cbuffer CBParticleData : register( b6 )
{
	float4 posp;
	float widthp;
	float heightp;
	float2 texup;
	float2 texvp;
	float2 dummyp;
};
cbuffer CBMaterialData : register( b7 )
{
	float4 faceColor;
	float power;
	float3 specularColor;
	int texsrvno;
	float3 emissiveColor;
	float ktex;
	float kdif;
	float kemi;
	float kspc;
	float3 lightpos;
	int projmode;
	float3 campos;
	float caseparam0;
	float3 ambientcolor;
	float caseparam1;
};
cbuffer CBMatrixData0 : register( b8 )
{
	matrix matrixparam0[120];
};
cbuffer CBIntData0 : register( b9 )
{
	int intparam0[64];
};
cbuffer CBFloat4Data0 : register( b10 )
{
	float4 float4param0[64];
};
cbuffer CBParticleHair : register( b11 )
{
	uint hairvertexnum;
	float sectionlength;
	float finithairrootnum;
	uint numfromhairroot;
	float hairspreadrad;
	float vtx01hrzrotrad;
	float vtx01vrtrotrad;
	int phparami;
	matrix moveworld;
	uint hairColormode;
	float3 hairColor;
};
//--------------------------------------------------------------------------------------
struct VSshade0_INPUT
{
    float3 Pos : POSITION;
    float2 Tex : TEXCOORD0;
    int shapekeyindicate : SHAPEKEYI;
};
struct VSshade1_INPUT
{
    float3 Pos : POSITION;
    float2 Tex : TEXCOORD0;
    float3 Norm : NORMAL;
    int shapekeyindicate : SHAPEKEYI;
};
struct VSshade0ba_INPUT
{
    float3 Pos : POSITION;
    float2 Tex : TEXCOORD0;
    int shapekeyindicate : SHAPEKEYI;
    int joint0 : JOINTNO0;
	float weight0 : WEIGHT0;
	int joint1 : JOINTNO1;
	float weight1 : WEIGHT1;
};
struct VSshade1ba_INPUT
{
    float3 Pos : POSITION;
    float2 Tex : TEXCOORD0;
    float3 Norm : NORMAL;
    int shapekeyindicate : SHAPEKEYI;
    int joint0 : JOINTNO0;
	float weight0 : WEIGHT0;
	int joint1 : JOINTNO1;
	float weight1 : WEIGHT1;
};
struct PSshade0_INPUT
{
    float4 Pos : SV_POSITION;
    float3 PosWorld : POSWORLD;
    float3 Norm : NORMAL;
    float2 Tex : TEXCOORD0;
};
struct PS_INPUT
{
    float4 Pos : SV_POSITION;
    float2 Tex : TEXCOORD0;
};
struct PS_INPUTpoint
{
    float4 Pos : SV_POSITION;
    float4 Col : COLOR;
};
struct GSparticlehair_INPUT
{
    float3 Pos : POSITION;
    float2 Tex : TEXCOORD0;
    uint InstID : SV_InstanceID;
};
//--------------------------------------------------------------------------------------
// Vertex Shader///--------------------------------------------------------------------------------------
VSshade0_INPUT VSshade0( VSshade0_INPUT input )
{
	VSshade0_INPUT output;
	float4 pos4 = 0;
	
	if(intparam0[0] == 1){
		input.Pos.x += float4param0[input.shapekeyindicate].x;
		input.Pos.y += float4param0[input.shapekeyindicate].y;
		input.Pos.z += float4param0[input.shapekeyindicate].z;
	}
	pos4 = float4(input.Pos,1.0);
	pos4 = mul(pos4,World);
	output.Pos = pos4.xyz;
	output.Tex = input.Tex;
	
    return output;
}
GSparticlehair_INPUT VSshade0ph( VSshade0_INPUT input, uint InstID : SV_InstanceID)
{
	GSparticlehair_INPUT output;
	float4 pos4 = 0;
	
	if(intparam0[0] == 1){
		input.Pos.x += float4param0[input.shapekeyindicate].x;
		input.Pos.y += float4param0[input.shapekeyindicate].y;
		input.Pos.z += float4param0[input.shapekeyindicate].z;
	}
	pos4 = float4(input.Pos,1.0);
	pos4 = mul(pos4,World);
	output.Pos = pos4.xyz;
	output.Tex = input.Tex;
	output.InstID = InstID;
    return output;
}
PSshade0_INPUT VSshade1( VSshade1_INPUT input )
{
	PSshade0_INPUT output;
    float4 pos4 = 0;
    float3 pos3 = 0;
    
	if(intparam0[0] == 1){
		input.Pos.x += float4param0[input.shapekeyindicate].x;
		input.Pos.y += float4param0[input.shapekeyindicate].y;
		input.Pos.z += float4param0[input.shapekeyindicate].z;
	}
	output.Tex = input.Tex;
	pos4 = float4(input.Norm,0.0);
	pos4 = mul( pos4, World );
	pos3 = pos4.xyz;
	output.Norm = normalize(pos3);
	pos4 = float4(input.Pos,1.0);
	output.Pos = mul(pos4, World );
	output.PosWorld = output.Pos.xyz;
	output.Pos = mul(output.Pos, View );
	output.Pos = mul(output.Pos, Projection);
    
    return output;
}
GSparticlehair_INPUT VSshade1ph( VSshade1_INPUT input ,uint InstID : SV_InstanceID)
{
	GSparticlehair_INPUT output;
    float4 pos4 = 0;
    float3 pos3 = 0;
    
	if(intparam0[0] == 1){
		input.Pos.x += float4param0[input.shapekeyindicate].x;
		input.Pos.y += float4param0[input.shapekeyindicate].y;
		input.Pos.z += float4param0[input.shapekeyindicate].z;
	}
    pos4 = float4(input.Pos,1.0);
	pos4 = mul(pos4,World);
	output.Pos = pos4.xyz;
	output.Tex = input.Tex;
	output.InstID = InstID;
    return output;
}
VSshade0_INPUT VSshade0ba( VSshade0ba_INPUT input )
{
	VSshade0_INPUT output;
	float4 pos4a = 0;
	float4 pos4b = 0;
	
	if(intparam0[0] == 1){
		input.Pos.x += float4param0[input.shapekeyindicate].x;
		input.Pos.y += float4param0[input.shapekeyindicate].y;
		input.Pos.z += float4param0[input.shapekeyindicate].z;
	}
	pos4a = float4(input.Pos,1.0);
	pos4b = input.weight0 * mul(pos4a,matrixparam0[input.joint0]);
	if(input.joint1 >= 0){
		pos4a = input.weight1 * mul(pos4a,matrixparam0[input.joint1]);
		pos4b += pos4a;
	}
	pos4b = mul(pos4b,World);
	output.Pos = pos4b.xyz;
	output.Tex = input.Tex;
	
    return output;
}
GSparticlehair_INPUT VSshade0baph( VSshade0ba_INPUT input ,uint InstID : SV_InstanceID)
{
	GSparticlehair_INPUT output;
	float4 pos4a = 0;
	float4 pos4b = 0;
	
	if(intparam0[0] == 1){
		input.Pos.x += float4param0[input.shapekeyindicate].x;
		input.Pos.y += float4param0[input.shapekeyindicate].y;
		input.Pos.z += float4param0[input.shapekeyindicate].z;
	}
	pos4a = float4(input.Pos,1.0);
	pos4b = input.weight0 * mul(pos4a,matrixparam0[input.joint0]);
	if(input.joint1 >= 0){
		pos4a = input.weight1 * mul(pos4a,matrixparam0[input.joint1]);
		pos4b += pos4a;
	}
	pos4b = mul(pos4b,World);
	output.Pos = pos4b.xyz;
	output.Tex = input.Tex;
	output.InstID = InstID;
    return output;
}
PSshade0_INPUT VSshade1ba( VSshade1ba_INPUT input )
{
	PSshade0_INPUT output;
    float4 pos4n0 = 0;
    float4 pos4w0 = 0;
    float4 pos4n1 = 0;
    float4 pos4w1 = 0;
    float3 pos3 = 0;
    
	if(intparam0[0] == 1){
		input.Pos.x += float4param0[input.shapekeyindicate].x;
		input.Pos.y += float4param0[input.shapekeyindicate].y;
		input.Pos.z += float4param0[input.shapekeyindicate].z;
	}
	output.Tex = input.Tex;
	pos4n0 = float4(input.Norm,0.0);
	pos4w0 = float4(input.Pos,1.0);
	pos4n1 = input.weight0 * mul(pos4n0,matrixparam0[input.joint0]);
	pos4w1 = input.weight0 * mul(pos4w0,matrixparam0[input.joint0]);
	if(input.joint1 >= 0){
		pos4n0 = input.weight1 * mul(pos4n0,matrixparam0[input.joint1]);
		pos4n1 += pos4n0;
		pos4w0 = input.weight1 * mul(pos4w0,matrixparam0[input.joint1]);
		pos4w1 += pos4w0;
	}
	pos4n0 = mul( pos4n1, World );
	pos3 = pos4n0.xyz;
	output.Norm = normalize(pos3);
	
	output.Pos = mul(pos4w1, World );
	output.PosWorld = output.Pos.xyz;
	output.Pos = mul(output.Pos, View );
	output.Pos = mul(output.Pos, Projection);
    
    return output;
}
GSparticlehair_INPUT VSshade1baph( VSshade1ba_INPUT input ,uint InstID : SV_InstanceID)
{
	GSparticlehair_INPUT output;
    float4 pos4w0 = 0;
    float4 pos4w1 = 0;
    float3 pos3 = 0;
    
	if(intparam0[0] == 1){
		input.Pos.x += float4param0[input.shapekeyindicate].x;
		input.Pos.y += float4param0[input.shapekeyindicate].y;
		input.Pos.z += float4param0[input.shapekeyindicate].z;
	}
	pos4w0 = float4(input.Pos,1.0);
	pos4w1 = input.weight0 * mul(pos4w0,matrixparam0[input.joint0]);
	if(input.joint1 >= 0){
		pos4w0 = input.weight1 * mul(pos4w0,matrixparam0[input.joint1]);
		pos4w1 += pos4w0;
	}
	pos4w0 = mul(pos4w1, World );
	output.Pos = pos4w0.xyz;
    output.Tex = input.Tex;
    output.InstID = InstID;
    return output;
}
PS_INPUT VSsprite(uint vID : SV_VertexID)
{
	float4 pos = 0;
	float2 tex = 0;
	PS_INPUT output = (PS_INPUT)0;
	switch (vID)
	{
    case 0: pos = float4(posx.x,posy.x,posz.x,1.0); tex = float2(texu.x,texv.x); break;
    case 1: pos = float4(posx.y,posy.y,posz.y,1.0); tex = float2(texu.y,texv.y); break;
    case 2: pos = float4(posx.z,posy.z,posz.z,1.0); tex = float2(texu.z,texv.z); break;
    case 3: pos = float4(posx.w,posy.w,posz.w,1.0); tex = float2(texu.w,texv.w); break;
    }
    if (posmode == 0){
	    output.Pos = pos;
	}
	else{
		output.Pos = mul( pos, World );
		output.Pos = mul( output.Pos, View );
		output.Pos = mul( output.Pos, Projection );
	}
    output.Tex = tex;
    return output;
}
PS_INPUTpoint VSpoint(uint vID : SV_VertexID)
{
	PS_INPUTpoint output = (PS_INPUTpoint)0;
	output.Pos = pos;
    output.Col = pointcolor;
    return output;
	
}
PS_INPUTpoint VSline(uint vID : SV_VertexID)
{
	PS_INPUTpoint output = (PS_INPUTpoint)0;
	switch (vID)
	{
    case 0: output.Pos = pos0; output.Col = pointcolor0; break;
    case 1: output.Pos = pos1; output.Col = pointcolor1; break;
    }
    return output;
	
}
PS_INPUT VSparticle(uint vID : SV_VertexID)
{
	float2 tex = 0;
	PS_INPUT output = (PS_INPUT)0;
	
	output.Pos = mul( posp, World );
	output.Pos = mul( output.Pos, View );
    output.Tex = tex;
    return output;
}

[maxvertexcount(4)]
void GS_PARTICLE(point PS_INPUT In[1],
                inout TriangleStream<PS_INPUT> ParticleStream)
{
    // _ʂɂ
    float4 posLT = In[0].Pos + float4(-widthp * 0.5,heightp * 0.5, 0.0, 0.0);
    float4 posLB = In[0].Pos + float4(-widthp * 0.5,-heightp * 0.5, 0.0, 0.0);
    float4 posRT = In[0].Pos + float4(widthp * 0.5,heightp * 0.5, 0.0, 0.0);
    float4 posRB = In[0].Pos + float4(widthp * 0.5,-heightp * 0.5, 0.0, 0.0);

    // ̓_̈ʒu(ˉeWn)vZďo
    PS_INPUT Out;
    Out.Pos = mul(posLT, Projection);
    Out.Tex = float2(texup.x,texvp.x);
    ParticleStream.Append(Out);

    // E̓_̈ʒu(ˉeWn)vZďo
    Out.Pos = mul(posRT, Projection);
    Out.Tex = float2(texup.y,texvp.x);
    ParticleStream.Append(Out);

    // ̓_̈ʒu(ˉeWn)vZďo
    PS_INPUT Out1;
    Out1.Pos = mul(posLB, Projection);
    Out1.Tex = float2(texup.x,texvp.y);
    ParticleStream.Append(Out1);

    // E̓_̈ʒu(ˉeWn)vZďo
    Out.Pos = mul(posRB, Projection);
    Out.Tex = float2(texup.y,texvp.y);
    ParticleStream.Append(Out);

    ParticleStream.RestartStrip();
}
[maxvertexcount(3)]
void GSshade0(triangle VSshade0_INPUT input[3],
        inout TriangleStream<PSshade0_INPUT> TriStream) {
        
    PSshade0_INPUT output;
    float4 pos4 = 0;

    // @xNǧvZ
    float3 faceEdge  = input[0].Pos;
    float3 faceEdgeA = input[1].Pos - faceEdge;
    float3 faceEdgeB = input[2].Pos - faceEdge;
    output.Norm = normalize(cross(faceEdgeA, faceEdgeB));

    // e_̌vZ
    for (int i=0; i<3; ++i) {
		output.Tex = input[i].Tex;
		pos4 = float4(input[i].Pos,1.0);
		output.Pos = mul(pos4, View );
		output.Pos = mul(output.Pos, Projection);
        output.PosWorld = input[i].Pos;
        // o
        TriStream.Append(output);
    }
    TriStream.RestartStrip();
}
[maxvertexcount(128)]
void GSparticlehair(triangle GSparticlehair_INPUT input[3],
        inout LineStream<PS_INPUTpoint> PHStream) {
        
    float3 vecAB = input[1].Pos - input[0].Pos;
    float3 vecAC = input[2].Pos - input[0].Pos;
    float3 vecBC = input[2].Pos - input[1].Pos;
    float3 clossABAC = cross(vecAB,vecAC);
    float3 normvecABC = normalize(clossABAC);
    float3 originalivec01hrz = normalize(vecAB);
    float3 originalivec01vrt = normalize(cross(clossABAC,vecAB));
    float hairrootperiod = sqrt(0.5 * length(clossABAC) / finithairrootnum);
    matrix rotv0v1horizontal = 0;
	float costheta = cos(vtx01hrzrotrad);
	float sintheta = sin(vtx01hrzrotrad);
	rotv0v1horizontal._m00 = pow(originalivec01hrz.x,2) * (1.0 - costheta) + costheta;
	rotv0v1horizontal._m01 = originalivec01hrz.x * originalivec01hrz.y * (1.0 - costheta) - originalivec01hrz.z * sintheta;
	rotv0v1horizontal._m02 = originalivec01hrz.x * originalivec01hrz.z * (1.0 - costheta) + originalivec01hrz.y * sintheta;
	rotv0v1horizontal._m10 = originalivec01hrz.x * originalivec01hrz.y * (1.0 - costheta) + originalivec01hrz.z * sintheta;
	rotv0v1horizontal._m11 = pow(originalivec01hrz.y,2) * (1.0 - costheta) + costheta;
	rotv0v1horizontal._m12 = originalivec01hrz.y * originalivec01hrz.z * (1.0 - costheta) - originalivec01hrz.x * sintheta;
	rotv0v1horizontal._m20 = originalivec01hrz.x * originalivec01hrz.z * (1.0 - costheta) - originalivec01hrz.y * sintheta;
	rotv0v1horizontal._m21 = originalivec01hrz.y * originalivec01hrz.z * (1.0 - costheta) + originalivec01hrz.x * sintheta;
	rotv0v1horizontal._m22 = pow(originalivec01hrz.z,2) * (1.0 - costheta) + costheta;
	matrix rotv0v1vertical = 0;
	costheta = cos(vtx01vrtrotrad);
	sintheta = sin(vtx01vrtrotrad);
	rotv0v1vertical._m00 = pow(originalivec01vrt.x,2) * (1.0 - costheta) + costheta;
	rotv0v1vertical._m01 = originalivec01vrt.x * originalivec01vrt.y * (1.0 - costheta) - originalivec01vrt.z * sintheta;
	rotv0v1vertical._m02 = originalivec01vrt.x * originalivec01vrt.z * (1.0 - costheta) + originalivec01vrt.y * sintheta;
	rotv0v1vertical._m10 = originalivec01vrt.x * originalivec01vrt.y * (1.0 - costheta) + originalivec01vrt.z * sintheta;
	rotv0v1vertical._m11 = pow(originalivec01vrt.y,2) * (1.0 - costheta) + costheta;
	rotv0v1vertical._m12 = originalivec01vrt.y * originalivec01vrt.z * (1.0 - costheta) - originalivec01vrt.x * sintheta;
	rotv0v1vertical._m20 = originalivec01vrt.x * originalivec01vrt.z * (1.0 - costheta) - originalivec01vrt.y * sintheta;
	rotv0v1vertical._m21 = originalivec01vrt.y * originalivec01vrt.z * (1.0 - costheta) + originalivec01vrt.x * sintheta;
	rotv0v1vertical._m22 = pow(originalivec01vrt.z,2) * (1.0 - costheta) + costheta;
	rotv0v1horizontal = mul(rotv0v1horizontal,rotv0v1vertical);
	
	float3 gravitycenterpos = (input[0].Pos + input[1].Pos + input[2].Pos) / 3.0;
	float2 gravitycentertex = (input[0].Tex + input[1].Tex + input[2].Tex) / 3.0;
	float2 tex0 = 0;
	float2 tex1 = 0;
	float2 tex2 = 0;
	float3 pos0 = 0;
	 switch(input[0].InstID)
    {
    case 0:
		pos0 = input[0].Pos;
		vecAB = input[1].Pos - input[0].Pos;
		vecAC = gravitycenterpos - input[0].Pos;
		vecBC = gravitycenterpos - input[1].Pos;
		tex0 = input[0].Tex;
		tex1 = input[1].Tex;
		tex2 = gravitycentertex;
	break;
	case 1:
		pos0 = gravitycenterpos;
		vecAB = input[1].Pos - gravitycenterpos;
		vecAC = input[2].Pos - gravitycenterpos;
		vecBC = input[2].Pos - input[1].Pos;
		tex0 = gravitycentertex;
		tex1 = input[1].Tex;
		tex2 = input[2].Tex;
	break;
	case 2:
		pos0 = gravitycenterpos;
		vecAB = input[2].Pos - gravitycenterpos;
		vecAC = input[0].Pos - gravitycenterpos;
		vecBC = input[0].Pos - input[2].Pos;
		tex0 = gravitycentertex;
		tex1 = input[2].Tex;
		tex2 = input[0].Tex;
	break;
	}
   
    float lAB = length(vecAB);
    float lAC = length(vecAC);
    float lBC = length(vecBC);
    clossABAC = cross(vecAB,vecAC);
    float sinA = length(clossABAC) / lAB / lAC;
    float cosA = dot(vecAB,vecAC) / lAB / lAC;
    float sinB = lAC * sinA / lBC;
    float cosB = dot(-vecAB,vecBC) / lAB / lBC;
    float r = 0.0;
    float l = 0.0;
    float lCD = lBC * sinB;
    
    float3 evecx = hairrootperiod * normalize(vecAB);
    float3 evecy = hairrootperiod * normalize(cross(clossABAC,vecAB));
    float3 dr = 0;
    float3 light = 0;
    float bright = 0.0;
    float3 tempveca = 0;
    float3 linenormlight = 0;
    float3 linenormcamera = 0;
    float4 emissiveColor4 = float4(emissiveColor,1.0);
    float3 R = 0;
	float3 V = 0;
	float4 specularColor4 = float4(specularColor,1.0);
	float4 ambientcolor4 = float4(ambientcolor,1.0);
	float4 hairColor4 = float4(hairColor,1.0);
	float4 pos4 = 0;
	float3 pos3 = 0;
	
	
	matrix spreadmatrix = 0;
	
    PS_INPUTpoint output;
    
    int ixa = 0;
    int ixb = 0;
    int iya = 0;
    int iyb = floor(lCD / hairrootperiod);
    uint ivertexhaircnt = 0;
    
    l = hairrootperiod / sinA;
	r = hairrootperiod / sinB;
	uint colorcnt = 0;
	float dcolor = 0.1;
	uint hairvolume = 0; 
	float hairrootcnt = 0.0;
	float3 vec0p = 0;
	float jyuusin0 = 0.0;
	float jyuusin1 = 0.0;
	float jyuusin2 = 0.0;
	float2 phtex = 0;
	float3 texCoord3 = 0;
	uint width = 0;
	uint height = 0;
	
	int jx = 0;
    int jy = 0;
    float fcnt = 0.0;
   
   
	
	
    uint instfirstloopydir = 0;
    uint totalvertexcnt = 0;
    uint hairroothavevertexnum = numfromhairroot * hairvertexnum;
    int ibreak = 0;
	
	while(jy <= iyb)
	{
		ixa = ceil(fcnt * l * cosA / hairrootperiod);
		ixb = floor((-fcnt * r * cosB + lAB)/ hairrootperiod);
		if(input[0].InstID == 0){
			jx = ixa;
		}
		else{
			if(instfirstloopydir > 0) jx = ixa;
		}
		
		
		while(jx <= ixb)
		{ 
			if(ibreak == 1) break;
			ivertexhaircnt = 0;
			emissiveColor4 = float4(emissiveColor,1.0);
			pos3 = pos0 + jx * evecx + jy * evecy;
			pos4 = float4(pos3,1.0);
			output.Pos = mul(pos4, View );
			output.Pos = mul(output.Pos, Projection);
			
			dr = normvecABC;
			light = lightpos - pos3;
			tempveca = cross(dr,light);
			linenormlight = normalize(cross(tempveca,dr));
			bright = dot(normalize(light), linenormlight);
			switch(hairColormode)
			{
			case 0:
				output.Col = kdif * bright * faceColor;
				switch(colorcnt % 3)
				{
				case 0:
					emissiveColor4.x += dcolor * sin(0.523 * hairrootcnt);
				break;	
				case 1:
					emissiveColor4.y += dcolor * sin(1.04 * hairrootcnt);
				break;
				case 2:
					emissiveColor4.z += dcolor * sin(0.785 * hairrootcnt);
				break;
				}
			break;
			case 1:
				output.Col = kdif * bright * hairColor4;
				emissiveColor4 = hairColor4;
				switch(colorcnt % 3)
				{
				case 0:
					emissiveColor4.x += dcolor * sin(0.523 * hairrootcnt);
				break;	
				case 1:
					emissiveColor4.y += dcolor * sin(1.04 * hairrootcnt);
				break;
				case 2:
					emissiveColor4.z += dcolor * sin(0.785 * hairrootcnt);
				break;
				}
			break;
			case 2:
				output.Col = kdif * bright * faceColor;
				vec0p = jx * evecx + jy * evecy;
				jyuusin2 = length(cross(vecAB,vec0p)) / length(clossABAC);
				jyuusin1 = length(cross(vec0p,vecAC)) / length(clossABAC);
				jyuusin0 = 1.0 - jyuusin1 - jyuusin2;
				phtex = jyuusin0 * tex0 + jyuusin1 * tex1 + jyuusin2 * tex2;
				txDiffuse.GetDimensions(width,height);
				texCoord3 = float3(phtex.x * width,phtex.y * height,0);
				emissiveColor4 = ktex * txDiffuse.Load(texCoord3);
			break;
			}
			output.Col += kemi * emissiveColor4;
			V = normalize(campos - pos3);
			tempveca = cross(dr,V);
			linenormcamera = normalize(cross(tempveca,dr));
			tempveca = 0.5 * (linenormlight + linenormcamera);
			if(length(tempveca) != 0){
				R = reflect(normalize(-light),tempveca);
				bright = pow(saturate(dot(R,V)),power);
			}
			else{
				bright = 0.0;
			}
			output.Col += kspc * bright * specularColor4;
			output.Col += ambientcolor4;
			output.Col.w = faceColor.w;
			
			PHStream.Append(output);
			ivertexhaircnt++;
			totalvertexcnt++;
			
			while(ivertexhaircnt <= hairvertexnum)
			{
				if((hairvolume != 0)&&(ivertexhaircnt == 1)){
					dr = mul(dr,spreadmatrix);
					dr = mul(dr,rotv0v1horizontal);
					dr = mul(dr,moveworld);
				}
				else{
					dr = mul(dr,rotv0v1horizontal);
					dr = mul(dr,moveworld);
				}
				pos3 += sectionlength * dr;
				pos4 = float4(pos3,1.0);
				output.Pos = mul(pos4, View );
				output.Pos = mul(output.Pos, Projection);
				
				light = lightpos - pos3;
				tempveca = cross(dr,light);
				linenormlight = normalize(cross(tempveca,dr));
				bright = dot(normalize(light), linenormlight);
		
				if(hairColormode == 1){
					output.Col = kdif * bright * hairColor4;
				}
				else{
					output.Col = kdif * bright * faceColor;
				}
				output.Col += kemi * emissiveColor4;
				V = normalize(campos - pos3);
				tempveca = cross(dr,V);
				linenormcamera = normalize(cross(tempveca,dr));
				tempveca = 0.5 * (linenormlight + linenormcamera);
				if(length(tempveca) != 0){
					R = reflect(normalize(-light),tempveca);
					bright = pow(saturate(dot(R,V)),power);
				}
				else{
					bright = 0.0;
				}
				output.Col += kspc * bright * specularColor4;
				output.Col += ambientcolor4;
				output.Col.w = faceColor.w;
				
				PHStream.Append(output);
				ivertexhaircnt++;
				totalvertexcnt++;
			}
			PHStream.RestartStrip();
			hairvolume++;
			if(hairvolume == numfromhairroot){
				jx++;
				colorcnt++;
				hairrootcnt += 1.0;
				hairvolume = 0;
				if(128 - totalvertexcnt < hairroothavevertexnum) ibreak = 1;
			}
			else{
				switch(hairvolume % 4)
				{
				case 0:
					costheta = cos(hairspreadrad);
					sintheta = sin(hairspreadrad);
					spreadmatrix._m00 = pow(originalivec01hrz.x,2) * (1.0 - costheta) + costheta;
					spreadmatrix._m01 = originalivec01hrz.x * originalivec01hrz.y * (1.0 - costheta) - originalivec01hrz.z * sintheta;
					spreadmatrix._m02 = originalivec01hrz.x * originalivec01hrz.z * (1.0 - costheta) + originalivec01hrz.y * sintheta;
					spreadmatrix._m10 = originalivec01hrz.x * originalivec01hrz.y * (1.0 - costheta) + originalivec01hrz.z * sintheta;
					spreadmatrix._m11 = pow(originalivec01hrz.y,2) * (1.0 - costheta) + costheta;
					spreadmatrix._m12 = originalivec01hrz.y * originalivec01hrz.z * (1.0 - costheta) - originalivec01hrz.x * sintheta;
					spreadmatrix._m20 = originalivec01hrz.x * originalivec01hrz.z * (1.0 - costheta) - originalivec01hrz.y * sintheta;
					spreadmatrix._m21 = originalivec01hrz.y * originalivec01hrz.z * (1.0 - costheta) + originalivec01hrz.x * sintheta;
					spreadmatrix._m22 = pow(originalivec01hrz.z,2) * (1.0 - costheta) + costheta;
				break;
				case 1:
					costheta = cos(hairspreadrad);
					sintheta = sin(hairspreadrad);
					spreadmatrix._m00 = pow(originalivec01vrt.x,2) * (1.0 - costheta) + costheta;
					spreadmatrix._m01 = originalivec01vrt.x * originalivec01vrt.y * (1.0 - costheta) - originalivec01vrt.z * sintheta;
					spreadmatrix._m02 = originalivec01vrt.x * originalivec01vrt.z * (1.0 - costheta) + originalivec01vrt.y * sintheta;
					spreadmatrix._m10 = originalivec01vrt.x * originalivec01vrt.y * (1.0 - costheta) + originalivec01vrt.z * sintheta;
					spreadmatrix._m11 = pow(originalivec01vrt.y,2) * (1.0 - costheta) + costheta;
					spreadmatrix._m12 = originalivec01vrt.y * originalivec01vrt.z * (1.0 - costheta) - originalivec01vrt.x * sintheta;
					spreadmatrix._m20 = originalivec01vrt.x * originalivec01vrt.z * (1.0 - costheta) - originalivec01vrt.y * sintheta;
					spreadmatrix._m21 = originalivec01vrt.y * originalivec01vrt.z * (1.0 - costheta) + originalivec01vrt.x * sintheta;
					spreadmatrix._m22 = pow(originalivec01vrt.z,2) * (1.0 - costheta) + costheta;
				break;
				case 2:
					costheta = cos(-hairspreadrad);
					sintheta = sin(-hairspreadrad);
					spreadmatrix._m00 = pow(originalivec01hrz.x,2) * (1.0 - costheta) + costheta;
					spreadmatrix._m01 = originalivec01hrz.x * originalivec01hrz.y * (1.0 - costheta) - originalivec01hrz.z * sintheta;
					spreadmatrix._m02 = originalivec01hrz.x * originalivec01hrz.z * (1.0 - costheta) + originalivec01hrz.y * sintheta;
					spreadmatrix._m10 = originalivec01hrz.x * originalivec01hrz.y * (1.0 - costheta) + originalivec01hrz.z * sintheta;
					spreadmatrix._m11 = pow(originalivec01hrz.y,2) * (1.0 - costheta) + costheta;
					spreadmatrix._m12 = originalivec01hrz.y * originalivec01hrz.z * (1.0 - costheta) - originalivec01hrz.x * sintheta;
					spreadmatrix._m20 = originalivec01hrz.x * originalivec01hrz.z * (1.0 - costheta) - originalivec01hrz.y * sintheta;
					spreadmatrix._m21 = originalivec01hrz.y * originalivec01hrz.z * (1.0 - costheta) + originalivec01hrz.x * sintheta;
					spreadmatrix._m22 = pow(originalivec01hrz.z,2) * (1.0 - costheta) + costheta;
				break;
				case 3:
					costheta = cos(-hairspreadrad);
					sintheta = sin(-hairspreadrad);
					spreadmatrix._m00 = pow(originalivec01vrt.x,2) * (1.0 - costheta) + costheta;
					spreadmatrix._m01 = originalivec01vrt.x * originalivec01vrt.y * (1.0 - costheta) - originalivec01vrt.z * sintheta;
					spreadmatrix._m02 = originalivec01vrt.x * originalivec01vrt.z * (1.0 - costheta) + originalivec01vrt.y * sintheta;
					spreadmatrix._m10 = originalivec01vrt.x * originalivec01vrt.y * (1.0 - costheta) + originalivec01vrt.z * sintheta;
					spreadmatrix._m11 = pow(originalivec01vrt.y,2) * (1.0 - costheta) + costheta;
					spreadmatrix._m12 = originalivec01vrt.y * originalivec01vrt.z * (1.0 - costheta) - originalivec01vrt.x * sintheta;
					spreadmatrix._m20 = originalivec01vrt.x * originalivec01vrt.z * (1.0 - costheta) - originalivec01vrt.y * sintheta;
					spreadmatrix._m21 = originalivec01vrt.y * originalivec01vrt.z * (1.0 - costheta) + originalivec01vrt.x * sintheta;
					spreadmatrix._m22 = pow(originalivec01vrt.z,2) * (1.0 - costheta) + costheta;
				break;
				}
				
			}
		}
		if(ibreak == 1) break;
		fcnt += 1.0;
		jy++;
		instfirstloopydir++;
	}
}
[maxvertexcount(4)]
void GStoolpoint(point GSparticlehair_INPUT In[1],
                inout TriangleStream<PS_INPUTpoint> ParticleStream)
{
	PS_INPUTpoint Out;
	
    float4 pos4 = float4(In[0].Pos,1.0);
	pos4 = mul( pos4, View );
	pos4 = mul(pos4, Projection);
	pos4 = pos4.xyzw / pos4.w;
	float dw = 5.0 / caseparam0;
	float dh = 5.0 / caseparam1;
	
    float4 posLT = pos4 + float4(-dw,dh, 0.0, 0.0);
    float4 posLB = pos4 + float4(-dw,-dh, 0.0, 0.0);
    float4 posRT = pos4 + float4(dw,dh, 0.0, 0.0);
    float4 posRB = pos4 + float4(dw,-dh, 0.0, 0.0);

	
	Out.Col = (texsrvno == -1) ? float4(1.0,0.0,1.0,1.0) : float4(0.0,1.0,1.0,1.0);
	
    Out.Pos = posLT;
    ParticleStream.Append(Out);

    Out.Pos = posRT;
    ParticleStream.Append(Out);

    Out.Pos = posLB;
    ParticleStream.Append(Out);

	Out.Pos = posRB;
    ParticleStream.Append(Out);

    ParticleStream.RestartStrip();
}
[maxvertexcount(4)]
void GStoolline(triangle GSparticlehair_INPUT input[3],
                inout LineStream<PS_INPUTpoint> PHStream)
{
	PS_INPUTpoint Out0;
	PS_INPUTpoint Out;
	float4 pos4 = 0;
	Out.Col = float4(1.0,0.0,1.0,1.0);
	Out0.Col = float4(1.0,0.0,1.0,1.0);
	
	pos4 = float4(input[0].Pos,1.0);
	pos4 = mul( pos4, View );
	Out0.Pos = mul(pos4, Projection);
	PHStream.Append(Out0);
	
	for (int i=1; i<3; i++) {
		pos4 = float4(input[i].Pos,1.0);
		pos4 = mul( pos4, View );
		Out.Pos = mul(pos4, Projection);
		PHStream.Append(Out);
	}
	PHStream.Append(Out0);

    PHStream.RestartStrip();
}
//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------
float4 PS( PS_INPUT input) : SV_Target
{
	float4 outputcol = 0;
	outputcol = txDiffuse.Sample( samLinear, input.Tex );
	if (outputcol.x == 0.0 && outputcol.y == 0.0 &&outputcol.z == 0.0) discard;
    return outputcol;
}
float4 PSpoint( PS_INPUTpoint input) : SV_Target
{
    return input.Col;
}
float4 PSddsalpha( PS_INPUT input) : SV_Target
{
	float4 outputcol = 0;
	outputcol = txDiffuse.Sample( samLinear, input.Tex );
	if (outputcol.w < 1.0) discard;
    return outputcol;
}
float4 PSshade0( PSshade0_INPUT input) : SV_Target
{
	float3 light = lightpos - input.PosWorld;
	float length0 = length(light);
	//float bright = 30.0 * dot(normalize(light), input.Norm) / pow(length0, 2);
	float bright = 0.0;
	float3 R = reflect(normalize(-light),input.Norm);
	float3 V = normalize(campos - input.PosWorld);
	float4 outputcol = 0;
	float4 emissiveColor4 = float4(emissiveColor,1.0);
	float4 specularColor4 = float4(specularColor,1.0);
	float4 ambientcolor4 = float4(ambientcolor,1.0);
	float alpha = 0.0;
	
	if (texsrvno != -1){
		outputcol = ktex * txDiffuse.Sample( samLinear, input.Tex );
		if (outputcol.x == 0.0 && outputcol.y == 0.0 &&outputcol.z == 0.0) discard;
		alpha = outputcol.w * faceColor.w;
		bright = dot(normalize(light), input.Norm) + 1.0;
		outputcol = kdif * bright * outputcol * faceColor + kemi * outputcol * emissiveColor4; 
		bright = pow(saturate(dot(R,V)),power);
		outputcol += kspc * bright * specularColor4;
		outputcol += ambientcolor4;
		outputcol.w = alpha;
	}
	else{
		bright = dot(normalize(light), input.Norm) + 1.0;
		outputcol = kdif * bright * faceColor;
		outputcol += kemi * emissiveColor4;
		bright = pow(saturate(dot(R,V)),power);
		outputcol += kspc * bright * specularColor4;
		outputcol += ambientcolor4;
		outputcol.w = faceColor.w;
	}
    return saturate(outputcol);
}